/**
 * unittest.cpp - Bitcoin poscript generator
 *
 * Copyright (C)2015 The bitgen developers <bitgen@openmailbox.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */


#include "unittestCommon.h"

#include "pkif.h"
#include "pubKey.h"


#include <iostream>


namespace UnitTestCommon
{


void convertPkifAndBack(const std::string& pkifStr)
{
	std::cout << "Converting pkif: " << pkifStr << "............" << std::flush;
	const PubKey pubKey = PubKey::fromPkif(pkifStr);
	
	const Pkif convertedPkif = pubKey.getPkif();

	if(pkifStr != convertedPkif.toString())
	{
		std::cout << "Error, pkif mismatch: " << pkifStr << " and " << convertedPkif.toString() << std::endl;
		throw std::string("Pkif mismatch");
	}
	
	std::cout << "OK" << std::endl;

}



}
