#!/usr/bin/python

import os
import sys
import os.path

def printHeader(str) :
   "Prints header text"
   print "===================== " + str + " ====================="
   return

if not os.path.isfile("../bitgen-xmr"):
	print "Error, application binary does not exist"
	sys.exit()

#============ Start of tests ============

retval1 = os.system("../bitgen-xmr setnextnum 103")
if retval1 != 0:
	print "test init error"
	sys.exit()


printHeader("Test 1 bitgen-xmr paymentId")
retval1 = os.system("../bitgen-xmr paymentId 47BhELqqJYiW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg6rExHWF 0123456789ABCDEF | tee output_integrated.txt")
if retval1 != 0:
	print "test 1 error"
	sys.exit()


if not os.path.isfile("output_integrated.txt"):
	print "test 1 file error"
	sys.exit()


with open("output_integrated.txt") as f:
	content1 = f.read()  
	#print content1
	if "47BhELqqJYiW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg6rExHWF" not in content1: 
		print "test 1 file error 1"
		sys.exit()

	if "0123456789ABCDEF" not in content1: 
		print "test 1 file error 2"
		sys.exit()

	if "4GtNF9fKupEW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg9XookkUsPCQU3eQPBQ" not in content1: 
		print "test 1 file error 3"
		sys.exit()



#---------------------------------------------------------------------

printHeader("Test 2 bitgen-xmr paymentId")
retval1 = os.system("../bitgen-xmr paymentId 4GtNF9fKupEW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg9XookkUsPCQU3eQPBQ 0123456789ABCDEF  | tee output_integrated2.txt")
if retval1 != 0:
	print "test 2 error"
	sys.exit()


if not os.path.isfile("output_integrated2.txt"):
	print "test 2 file error"
	sys.exit()



with open("output_integrated2.txt") as f:
	content1 = f.read()  
	#print content1
	if "Original address   : 4GtNF9fKupEW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg9XookkUsPCQU3eQPBQ" not in content1: 
		print "test 2 file error 1"
		sys.exit()

	if "Integrated address : 4GtNF9fKupEW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg9XookkUsPCQU3eQPBQ" not in content1: 
		print "test 2 file error 2"
		sys.exit()


#sys.exit()

#---------------------------------------------------------------------

printHeader("Test 3 bitgen-xmr deriveprivview")
retval1 = os.system("../bitgen-xmr deriveprivview 48G1znkLzjagiURMWUnTxRjg3RTg7S51J33YGiSBLknJaE3mFyBGp56HX2baRedY2J1v6ZYxDnVdp1SP6M4Mea39EsspfHn 23C82E7F0897C54F1A7D61C64E80E91D5BBFCF97F8BAEE2D29FBBEB8A5A5E40C 5 0 | tee output_integrated3.txt")
if retval1 != 0:
	print "test 3 error"
	sys.exit()


if not os.path.isfile("output_integrated3.txt"):
	print "test 3 file error"
	sys.exit()

with open("output_integrated3.txt") as f:
	content1 = f.read()  
	#print content1
	if "48G1znkLzjagiURMWUnTxRjg3RTg7S51J33YGiSBLknJaE3mFyBGp56HX2baRedY2J1v6ZYxDnVdp1SP6M4Mea39EsspfHn" not in content1: 
		print "test 3 file error 1"
		sys.exit()

	if "839SwJqUDpF7c7jSAn8PVifPhKBrfnyPpcQP6eg35AdfLA9HEsMe1Na9aPx2qQwF5pYTJQ3ecx9EL1uJovQzc4mXVFLP8pB" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "84v3xW5xWBWYvVuNahDiP27yGcc2bUcY7CMFp237Gow6Eiv5DzaxxsMZTPp3cpppuCaZMNS7LkxJTd8CyAQEEYfMEt9HmHq" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "88oU8rmqZR4NRnnquNW1ZoZthxz7vBxQ5ijjVuBHpBpY2ySp4bKXwtVHjgogNEYsqccGnsVMa5cAtgF4i3F3JBjEUCjtP1u" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "89i4c1ePNQhSZ8KZu321FTUurQZmRKmnjKc3g1zsfmr53XLz1mdsSv16RLVa8pFrg2Njx594LzZHFBvBdZEBpUDe5NNBJDu" not in content1: 
		print "test 2 file error 2"
		sys.exit()


#---------------------------------------------------------------------


printHeader("Test 4 bitgen-xmr derive")
retval1 = os.system(".././bitgen-xmr derive \"gigantic july icon emotion quote vitals entrance adjust aside betting almost hull bacon optical soapy biology topic guarded howls seventh repent dodge guys hamburger biology\"  5 0 | tee output_integrated4.txt")
if retval1 != 0:
	print "test 4 error"
	sys.exit()

if not os.path.isfile("output_integrated4.txt"):
	print "test 4 file error"
	sys.exit()



with open("output_integrated4.txt") as f:
	content1 = f.read()  
	#print content1
	if "48G1znkLzjagiURMWUnTxRjg3RTg7S51J33YGiSBLknJaE3mFyBGp56HX2baRedY2J1v6ZYxDnVdp1SP6M4Mea39EsspfHn" not in content1: 
		print "test 3 file error 1"
		sys.exit()

	if "839SwJqUDpF7c7jSAn8PVifPhKBrfnyPpcQP6eg35AdfLA9HEsMe1Na9aPx2qQwF5pYTJQ3ecx9EL1uJovQzc4mXVFLP8pB" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "84v3xW5xWBWYvVuNahDiP27yGcc2bUcY7CMFp237Gow6Eiv5DzaxxsMZTPp3cpppuCaZMNS7LkxJTd8CyAQEEYfMEt9HmHq" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "88oU8rmqZR4NRnnquNW1ZoZthxz7vBxQ5ijjVuBHpBpY2ySp4bKXwtVHjgogNEYsqccGnsVMa5cAtgF4i3F3JBjEUCjtP1u" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "89i4c1ePNQhSZ8KZu321FTUurQZmRKmnjKc3g1zsfmr53XLz1mdsSv16RLVa8pFrg2Njx594LzZHFBvBdZEBpUDe5NNBJDu" not in content1: 
		print "test 2 file error 2"
		sys.exit()



#---------------------------------------------------------------------


printHeader("Test 5 bitgen-xmr deriveprivspend")
retval1 = os.system("../bitgen-xmr deriveprivspend 8EA48BF2158C5D4026F7AB0D2AE9DC5B1B9E4F2D6C513E7D38AC6DF2AAF84801 5 0 | tee output_integrated5.txt")
if retval1 != 0:
	print "test 5 error"
	sys.exit()


if not os.path.isfile("output_integrated5.txt"):
	print "test 5 file error"
	sys.exit()


with open("output_integrated5.txt") as f:
	content1 = f.read()  
	#print content1
	if "48G1znkLzjagiURMWUnTxRjg3RTg7S51J33YGiSBLknJaE3mFyBGp56HX2baRedY2J1v6ZYxDnVdp1SP6M4Mea39EsspfHn" not in content1: 
		print "test 3 file error 1"
		sys.exit()

	if "839SwJqUDpF7c7jSAn8PVifPhKBrfnyPpcQP6eg35AdfLA9HEsMe1Na9aPx2qQwF5pYTJQ3ecx9EL1uJovQzc4mXVFLP8pB" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "84v3xW5xWBWYvVuNahDiP27yGcc2bUcY7CMFp237Gow6Eiv5DzaxxsMZTPp3cpppuCaZMNS7LkxJTd8CyAQEEYfMEt9HmHq" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "88oU8rmqZR4NRnnquNW1ZoZthxz7vBxQ5ijjVuBHpBpY2ySp4bKXwtVHjgogNEYsqccGnsVMa5cAtgF4i3F3JBjEUCjtP1u" not in content1: 
		print "test 2 file error 2"
		sys.exit()

	if "89i4c1ePNQhSZ8KZu321FTUurQZmRKmnjKc3g1zsfmr53XLz1mdsSv16RLVa8pFrg2Njx594LzZHFBvBdZEBpUDe5NNBJDu" not in content1: 
		print "test 2 file error 2"
		sys.exit()



#---------------------------------------------------------------------


printHeader("Test 6 bitgen-xmr deriveprivspend")
retval1 = os.system("../bitgen-xmr deriveprivspend C04D20AA99A34CBB60D2642E8AD921457D76FDCFFC43F40EC50814B0264C850D 6 0 | tee output_integrated6.txt")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("output_integrated6.txt"):
	print "test 6 file error"
	sys.exit()



with open("output_integrated6.txt") as f:
	content1 = f.read()  
	#print content1
	if "45NbqxMgnXrH3xtfHoTkmkGC22U1wdKspQEBGuxCobx4LAHLG6hJRTZjjtcQwSLAB4YxkGAjQrbnCfU54KpbxffYRvaR1mM" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "84x3MbGfbuTMmWPKGCvauU1BTMfnBEPVUPBgN5s88JpRXXf9mFf1QkzWafgaLuRY5rMjvtrG54F1L7nK189Uo1m5H1jmqqH" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "84Fpp8PueVGZiLxZLPSpupJaSX1gmrHadh4F6p6DnMkAFjaKUcHq9hFUceHu17sLtFPrCyoNCiaJnSpC5PeEvXHz8P9LyQu" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "8BYaFQeUBoJfTMfzKyPL39WouJ3FHYAwcidJ4tV5h74o1PPR3SZ4BmfdPZeyAFiVqtbYJWA3Hou7AJsn5hrtnV1jABtT1L8" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "82dWRZAKrKi8V6rsHpXexLbrqHySiq2ephzh4g7fZmE2hWNMLLS4Nhq6BLN2BmQdc5HST6NmW1iyuGuA3BRutG8ePWGa6Ns" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "833SFLUsgDtDZCUFghWkzead2P7MRjBz8NWzyMwXNbwF9QdqUd8prMDAZUySY2RLZ3RWQHPYJFjDN78MaqrZ3cYMC1b5xyw" not in content1: 
		print "test 6 file error 2"
		sys.exit()






#---------------------------------------------------------------------


printHeader("Test 7 bitgen-xmr info")
retval1 = os.system("../bitgen-xmr info 84x3MbGfbuTMmWPKGCvauU1BTMfnBEPVUPBgN5s88JpRXXf9mFf1QkzWafgaLuRY5rMjvtrG54F1L7nK189Uo1m5H1jmqqH | tee output_integrated7.txt")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("output_integrated7.txt"):
	print "test 6 file error"
	sys.exit()



with open("output_integrated7.txt") as f:
	content1 = f.read()  
	#print content1
	if "Public spend: 41DFFB618202CA7C28EFB58AF2785F0113DFF55A1328D384A152192558EE6AB6" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "Public view : 84BA5BB0532853B0D99C56956F4A157BFF4F87E693F1E3288ACF59A30A929C8D" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "Is subaddress" not in content1: 
		print "test 6 file error 2"
		sys.exit()






#---------------------------------------------------------------------


printHeader("Test 8 bitgen-xmr info")
retval1 = os.system("../bitgen-xmr info 4GtNF9fKupEW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg9XookkUsPCQU3eQPBQ | tee output_integrated8.txt")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("output_integrated8.txt"):
	print "test 6 file error"
	sys.exit()



with open("output_integrated8.txt") as f:
	content1 = f.read()  
	#print content1
	if "Address     : 4GtNF9fKupEW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg9XookkUsPCQU3eQPBQ" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "Payment id  : 0123456789ABCDEF" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "Is NOT subaddress" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "Public spend: 92C4718BAFE333ADDC582D3D70DDEF786908A631988C32926FAC172D5C94AC17" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "Public view : 57A7EE9BE2879A5683C111873D859BBCBCDE93BF60A18C96361635CAA7605933" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "Base address: 47BhELqqJYiW5fg2sXubveM98aS4YKYoBRVcf4qMWjUX4uT8kYxmaTbFUJSHhW8P1UYZzanvX6ufRS8En6ZYvEGg6rExHWF" not in content1: 
		print "test 6 file error 2"
		sys.exit()




#---------------------------------------------------------------------


printHeader("Test 9 bitgen-xmr info")
retval1 = os.system("../bitgen-xmr info 4Ef6CUp5kG2MmHoFQLk8ieGvU23s1qg8421J4WC8kH5ZWPUz75DEVy71SnLhf4wDxrj3Ec5baXdacVxE6h9tHjup1M41ALpCxsz4sZax2g | tee output_integrated9.txt")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("output_integrated9.txt"):
	print "test 6 file error"
	sys.exit()



with open("output_integrated9.txt") as f:
	content1 = f.read()  
	#print content1
	if "Payment id  : 1122112211221122" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "57F33E3E188C237C2335A0472BA6335F30BC16648D32D506024936F3598B10AF" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "B278C319930AEE02A8563D91BE4437FB54F974D40E912DAD17FD7E6AD59F0F02" not in content1: 
		print "test 6 file error 2"
		sys.exit()

	if "44xRBfzb8zWMmHoFQLk8ieGvU23s1qg8421J4WC8kH5ZWPUz75DEVy71SnLhf4wDxrj3Ec5baXdacVxE6h9tHjup1F9yQi9" not in content1: 
		print "test 6 file error 2"
		sys.exit()






#---------------------------------------------------------------------


printHeader("Test 10 bitgen-xmr deriveprivview")
retval1 = os.system("../bitgen-xmr deriveprivview 45kiKJvh2mEcurcqebGgoqCckNrsGKF1MPy3ZKdUaJu9HjXLF8JBDBgVatmBzmgMwC2wCz4rTAeAW2WSPB4iwLV1L4HBVFD 75FF886F931B9D3945DACA4E65ED82562C44A00366288AEEA6273A41943B3003 5 7 | tee output_integrated10.txt")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("output_integrated10.txt"):
	print "test 6 file error"
	sys.exit()



with open("output_integrated10.txt") as f:
	content1 = f.read()  
	#print content1
	if "86jH8RUvgNf5hAuHd372VQ51gZ7fw3asBCMdsjuwrbFa1KtboZAc1rFWQVenJAEiS1QgQpx9BqbakbgvoUZvQoXx4sEvPcV" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "88SEtNbfubfRhBtLPNqRKQifbYJcD1V5AaJ96wQfXaJmCdHeGWbBtNN9XCb12kvW6E4qhnD6CVw53V64ov8r33e9CkA7tHH" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "848itvJRgn9b1yxEwZ6WpQdz1AWCSGCRkE4DzoD8dvdKg98hLBkA22oTgX3dbG4gZ3RPWGN4P7DjERvGi7aZ6XYE3yE5LVG" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "88KRRQz24t4hYjWvdQWVgtNvoYa8W3CuULmJvunytnzeEw9qx3KoeembM3RabHz1J3PqFeQkMd1fYFnHy6Xvzbxy9rCuY2b" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "8BFMRxFxBwF5uQqrGJ1pxxSJbYbVdQw1g6bJCquk2CtQU8vSofquugsRUFsLwWHq9xYDvjJybTbmdQFdL1igMiyjV6JsQsQ" not in content1: 
		print "test 6 file error 1"
		sys.exit()





#---------------------------------------------------------------------


printHeader("Test 11 bitgen-xmr deriveprivspend")
retval1 = os.system("../bitgen-xmr deriveprivspend F4989D71B1751766298EE72EE039D8D83E4EE800C1B9463C37855602756B730B 5 0 | tee output_integrated11.txt")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("output_integrated11.txt"):
	print "test 6 file error"
	sys.exit()



with open("output_integrated11.txt") as f:
	content1 = f.read()  
	#print content1
	if "0: 48go895vTVcZ8thcbo2uYPRqkQrrdyySNX7mMZJE9LzjTQGYcCFSxKXeufEbXnD7nphpmNUjPXunq9GetHJayR3V1gTnwX8" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "1: 86g1ikbx8LGDqiwMo5s4y95Vq6zdbXZcM3PStkHjBv3XVhrXFjUHDqXZ8WTLFdBvF3hhd3EBmXN2sAqcKdfmzcfo2zBVYAo" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "2: 8A33wphe5AX7ZRUyQz4VUNKzgH7VmyUDBbxAedb6nHJyEThncKrcRFk5wM8y7ndT3QB42aEaRsUbF2Z8X9Ui1DNkU71ZNQz" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "3: 83B8Sq3pw6QGUfeH2CGoRYc3Uh76pQoSvNErBQr1DhPUANQbCXYaqTHeWnAWSgU2Qshi8uEHrBuoRjDbei4qUNh4LV2AqaS" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "4: 83S5vRNaqQZhvZfJ5N2bj2JTTsNGPQ4vF2WoxqubLk6SADYmEMRZRZRhvPEJcMXeZT73PYMkZX9DyHPjr8aXq1RkE3RK2Ep" not in content1: 
		print "test 6 file error 1"
		sys.exit()



print ""
print ""
print ""
print "Cleaning up"
os.system("rm *.txt *.ps")

print ""
print ""
print ""
print "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
print "++++++++++++++++++++++++++++++ All tests passed OK +++++++++++++++++++++++++++"
print "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"


sys.exit(123)
